<template>
  <v-select
    :items="typeNames"
    :label="labelText"
    :value="currentType"
    @input="setCurrentVisType"
  ></v-select>
</template>

<script>
import { mapState } from "vuex";

export default {
  props: {
    types: Array,
    side: String,
    labelText: String
  },

  computed: {
    ...mapState(["visualisation"]),
    typeNames() {
      return this.types.map(t => t.name);
    },
    currentType() {
      return this.types[this.visualisation[this.side].id].name;
    }
  },
  methods: {
    setCurrentVisType(name) {
      const id = this.types.findIndex(t => t.name === name);
      const { requirements, type } = this.types[id];
      const { side } = this;

      this.$store
        .dispatch("setVisType", {
          side,
          id,
          requirements,
          type
        })
        .then(() => {
          this.$router.go();
        });
    }
  }
};
</script>

<style></style>
